<script setup lang="ts">
import { monthsWithNum, getMonthAbbreviation } from '@/utils/date'
import ChartBox from '../components/ChartBox.vue'
import { useHomeStore } from '../store/home'
import { useLoadingStore } from '@/stores/loading'

const loader = useLoadingStore()
const store = useHomeStore()

defineProps<{
  title: string
}>()
</script>

<template>
  <v-col cols="12">
    <v-row no-gutters>
      <h2>{{ title }}</h2>
      <v-spacer></v-spacer>
      <h2>{{ store.selectBranch?.name ?? 'ALL' }}</h2>
    </v-row>
    <v-divider class="mt-2"></v-divider>
  </v-col>
  <v-col lg="4">
    <v-select
      v-model="store.revenueDTO.month"
      variant="solo"
      rounded="pill"
      label="Select a month"
      :items="monthsWithNum"
      item-title="label"
      item-value="number"
      clearable
    >
    </v-select>
    <ChartBox
      title="Day over Day"
      :chart-data="store.getRevenueDay?.map((item) => item.net)"
      :chart-labels="store.getRevenueDay.map((item) => item.date)"
    ></ChartBox>
  </v-col>
  <v-col lg="4">
    <v-select
      v-model="store.revenueDTO.year"
      variant="solo"
      rounded="pill"
      label="Select a year"
      :items="[2023, 2024]"
      clearable
    >
    </v-select>
    <ChartBox
      title="Month over Month"
      :chart-data="store.getRevenueMonth.map((item) => item.net)"
      :chart-labels="store.getRevenueMonth.map((item) => getMonthAbbreviation(+item.month))"
    />
  </v-col>
  <v-col lg="4">
    <v-card class="pa-4 mb-5 text-center" rounded="pill"
      >{{
        `Since ${store.getRevenueYear.map((item) => item.year).length > 0 ? store.getRevenueYear.map((item) => item.year) : '...'} `
      }}
    </v-card>
    <ChartBox
      title="Year over Year "
      :chart-data="store.getRevenueYear.map((item) => item.net)"
      :chart-labels="store.getRevenueYear.map((item) => item.year)"
    />
  </v-col>
  <v-col cols="12">
    <v-btn
      :loading="loader.isLoading"
      class="w-100"
      prepend-icon="mdi-autorenew"
      variant="outlined"
      rounded="pill"
      @click="store.fetchRevenue()"
      >reload data</v-btn
    >
  </v-col>
</template>
